# Conditional build:
%bcond_without	dlm_stonith	# build without fencing helper
#
Summary:	General-purpose distributed lock manager
Summary(pl.UTF-8):	Zarządca rozproszonych blokad ogólnego przeznaczenia
Name:		dlm
Version:	4.0.0
Release:	1
License:	LGPL v2.1+, GPL v2
Group:		Libraries
Source0:	http://people.redhat.com/teigland/%{name}-%{version}.tar.gz
# Source0-md5:	2db31a9728ede91a202ff6f3e5accf8d
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.tmpfiles
Source4:	dlm.conf
Patch0:		%{name}-perms.patch
URL:		http://sources.redhat.com/cluster/dlm/
BuildRequires:	corosync-devel >= 2.0
%{?with_dlm_stonith:BuildRequires:	pacemaker-devel >= 1.1}
BuildRequires:	rpmbuild(macros) >= 1.644
BuildRequires:	systemd-devel
Requires:	%{name}-libs = %{version}-%{release}
Requires:	rc-scripts
Requires:	systemd-units >= 38
Requires(post,preun):	/sbin/chkconfig
Obsoletes:	cluster-dlm
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The DLM lock manager is a kernel-based VMS-like distributed lock
manager. It is general purpose and not specific to only GFS or CLVM.
Kernel and userspace locking API's are available.

%description -l pl.UTF-8
Zarządca blokad DLM to oparty na jądrze zarządca rozproszonych blokad
w stylu VMS. Jest ogólnego przeznaczenia, przeznaczonym nie tylko dla
GFS-a czy CLVM-a. Dostępne są API blokowania w jądrze i przestrzeni
użytkownika.

%package libs
Summary:	DLM libraries
Summary(pl.UTF-8):	Biblioteki DLM
Group:		Development/Libraries
Obsoletes:	cluster-dlm-libs

%description libs
DLM libraries.

%description libs -l pl.UTF-8
Biblioteki DLM.

%package devel
Summary:	Header files and development documentation for DLM
Summary(pl.UTF-8):	Pliki nagłówkowe i dokumentacja programisty dla DLM-a
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Obsoletes:	cluster-dlm-devel

%description devel
Header files and development documentation for DLM.

%description devel -l pl.UTF-8
Pliki nagłówkowe i dokumentacja programisty dla DLM-a.

%prep
%setup -q
%patch0 -p1

%build
%{__make} \
	PREFIX=%{_prefix} \
	LIBNUM=%{_lib} \
	BINDIR=%{_sbindir} \
	LIBDIR=%{_libdir} \
	MANDIR=%{_mandir} \
	HDRDIR=%{_includedir} \
	CC="%{__cc} %{rpmcflags} %{rpmcppflags} %{rpmldflags}"

%if %{with dlm_stonith}
%{__make} -C fence \
	PREFIX=%{_prefix} \
	LIBNUM=%{_lib} \
	BINDIR=%{_sbindir} \
	LIBDIR=%{_libdir} \
	MANDIR=%{_mandir} \
	HDRDIR=%{_includedir} \
	CC="%{__cc} %{rpmcflags} %{rpmcppflags} %{rpmldflags}"
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{systemdunitdir},/etc/{rc.d/init.d,sysconfig}} \
               $RPM_BUILD_ROOT%{_sysconfdir}/%{name} \
               $RPM_BUILD_ROOT{/var/run/dlm,%{systemdtmpfilesdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	PREFIX=%{_prefix} \
	LIBNUM=%{_lib} \
	BINDIR=%{_sbindir} \
	LIBDIR=%{_libdir} \
	MANDIR=%{_mandir} \
	HDRDIR=%{_includedir}

%if %{with dlm_stonith}
%{__make} -C fence install \
	DESTDIR=$RPM_BUILD_ROOT \
	PREFIX=%{_prefix} \
	LIBNUM=%{_lib} \
	BINDIR=%{_sbindir} \
	LIBDIR=%{_libdir} \
	MANDIR=%{_mandir} \
	HDRDIR=%{_includedir}
%endif

install init/%{name}.service $RPM_BUILD_ROOT%{systemdunitdir}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
install %{SOURCE3} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/%{name}.conf
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/%{name}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%systemd_post %{name}.service

%preun
/sbin/chkconfig --add %{name}
%service %{name} restart
%systemd_preun %{name}.service

%postun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi
%systemd_reload

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README.license
%attr(755,root,root) %{_sbindir}/*
%dir %{_sysconfdir}/%{name}
%verify(not md5 mtime size) %config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
/lib/udev/rules.d/51-dlm.rules
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%verify(not md5 mtime size) %config(noreplace) /etc/sysconfig/%{name}
%{_mandir}/man8/*.8*
%{_mandir}/man5/dlm.conf.5*
%{systemdunitdir}/%{name}.service
%{systemdtmpfilesdir}/%{name}.conf
%dir /var/run/dlm

%files libs
%defattr(644,root,root,755)
%ghost %{_libdir}/libdlm.so.3
%attr(755,root,root) %{_libdir}/libdlm.so.3.*
%ghost %{_libdir}/libdlm_lt.so.3
%attr(755,root,root) %{_libdir}/libdlm_lt.so.3.*
%ghost %{_libdir}/libdlmcontrol.so.3
%attr(755,root,root) %{_libdir}/libdlmcontrol.so.3.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdlm.so
%attr(755,root,root) %{_libdir}/libdlm_lt.so
%attr(755,root,root) %{_libdir}/libdlmcontrol.so
%{_includedir}/libdlm.h
%{_includedir}/libdlmcontrol.h
%{_mandir}/man3/dlm_*.3*
%{_mandir}/man3/libdlm.3*
%{_pkgconfigdir}/libdlm.pc
%{_pkgconfigdir}/libdlm_lt.pc

%changelog
* Fri Nov 09 2012 Jacek Konieczny <jajcus@jajcus.net> ed04160
Version: 4.0.0

* Tue Nov 06 2012 Jacek Konieczny <jajcus@jajcus.net> bdb4b59
Use reboot by default instead of own hacks

* Fri Nov 02 2012 Jacek Konieczny <jkonieczny@eggsoft.pl> 0a090e0
Startup notification for dlm_controld

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 836bb7c
BR: corosync-devel >= 2.0

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> a474fbd
dlm_stonith BR fixed

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 2819e04
Release: 4

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 2d4edd9
Config file added

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 968f440
another dlm_stonith_reboot.patch ifx

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 813a2aa
dlm_stonith_reboot.patch fix

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 97d51e0
Add dlm_stonith_{reboot,off} aliases

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 1cb5a3b
dlm_controld-remove-fence_all-from-cli fedora patch

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> dd1619f
Ignore SIGHUP, do graceful exit on SIGINT

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> cb5cb0c
Use 'modprobe -q' instead of 2>/dev/null

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> d3afe32
Fix memory initialization in fence_config.c

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 5d349a4
adapterized

* Fri Nov 02 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 03ce58b
Requires and BuildRequires fixes

* Thu Nov 01 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 76b3d37
Build the dlm_stonith fencing helper

* Thu Nov 01 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> c0e659c
dlm requires dlm-libs, not the other way round

* Thu Nov 01 2012 Jacek Konieczny <jajcus@jajcus.net> 24bac79
init script header fix

* Thu Nov 01 2012 Jacek Konieczny <jajcus@jajcus.net> 4cfed2c
/var/run/dlm directory added

